SystemOrganization addCategory: #'Codex-Parser'!
SystemOrganization addCategory: #'Codex-Tests'!

SmaCCParser subclass: #CXParser
	instanceVariableNames: 'keywords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXParser class methodsFor: 'generated-comments' stamp: 'cwp 12/18/2009 10:51'!
parserDefinitionComment

	"%id <keyword>;
%id <name>;
%right <keyword>;

Section: 
	{#section0:}
	| Directive {#section1:}
	| Section Directive {#section2:};

Directive: 
	<keyword> <name> {#directive2:}
	| <keyword> <name> Value {#directive3:};

Value: 
	<name> {#value1:}
	| ""("" <name>* "")"" {#list:}
	| ""{"" Section ""}"" {#second:};

"! !

!CXParser class methodsFor: 'generated-accessing' stamp: 'cwp 12/18/2009 16:46'!
scannerClass
	^ CXScanner! !

!CXParser class methodsFor: 'generated-starting states' stamp: 'cwp 12/18/2009 10:51'!
startingStateForSection
	^1! !

!CXParser class methodsFor: 'generated-comments' stamp: 'cwp 12/18/2009 10:51'!
symbolComment

	"
1. ""(""
2. "")""
3. ""}""
4. ""{""
5. <whitespace>
6. <keyword>
7. <name>
8. Section
9. B e g i n
10. Value
11. Repeat: <name>
12. E O F
13. error
14. Directive
"! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/18/2009 16:46'!
directive2: tokens
	^ CXDirective 
		identifier: tokens first value
		name: tokens second value! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/18/2009 16:47'!
directive3: tokens
	^ CXDirective 
		identifier: tokens first value
		name: tokens second value
		value: tokens third value! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/16/2009 23:51'!
first: tokens
	^ tokens first! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 10:56'!
getNextToken
	super getNextToken.
	currentToken id = {scanner keywordId. scanner nameId} ifTrue: 
		[(keywords includes: currentToken value) ifFalse:
			[currentToken := SmaCCToken 
				value: currentToken value
				start: currentToken startPosition
				id: {scanner nameId}]]! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/17/2009 00:44'!
list: items
	| array tokens |
	tokens := items second.
	array := Array new: tokens size.
	tokens doWithIndex: [:token :index | array at: index  put: token value].
	^ array! !

!CXParser methodsFor: 'accessing' stamp: 'cwp 12/18/2009 10:46'!
parse
	self setDefaultKeywordsIfNone.
	^ super parse! !

!CXParser methodsFor: 'generated-reduction actions' stamp: 'cwp 12/18/2009 10:51'!
reduceActionForRepeatXXXnameX1: nodes 
	^ OrderedCollection new! !

!CXParser methodsFor: 'generated-reduction actions' stamp: 'cwp 12/18/2009 10:51'!
reduceActionForRepeatXXXnameX2: nodes 
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!CXParser methodsFor: 'generated-tables' stamp: 'cwp 12/18/2009 10:51'!
reduceTable
	^#(
#(8 0 #section0:)
#(8 1 #section1:)
#(8 2 #section2:)
#(9 1 #reduceFor:)
#(10 1 #value1:)
#(10 3 #list:)
#(10 3 #second:)
#(11 0 #reduceActionForRepeatXXXnameX1:)
#(11 2 #reduceActionForRepeatXXXnameX2:)
#(14 2 #directive2:)
#(14 3 #directive3:)
)! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/16/2009 23:36'!
second: items
	^ items second  ! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/18/2009 16:46'!
section0: items 
	^ CXSection new! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/18/2009 16:46'!
section1: items 
	^ CXSection with: items first! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/17/2009 00:38'!
section2: items
	^ items first 
		addDirective: items second;
		yourself! !

!CXParser methodsFor: 'initialize-release' stamp: 'cwp 12/18/2009 10:46'!
setDefaultKeywordsIfNone
	keywords ifNil:
		[keywords := #(
			alias
			blessing
			dependencies
			group
			import
			include
			package
			platform
			release
			repository
			section
			version
		) asSet]! !

!CXParser methodsFor: 'generated-tables' stamp: 'cwp 12/18/2009 10:51'!
transitionTable
	^#(
#(3 9 6 13 8 6 12 17 14)
#(2 21 7)
#(3 9 6 0 12 25 14)
#(2 10 3 6 12)
#(3 29 1 42 3 33 4 42 6 37 7 41 10 42 12)
#(2 14 3 6 12)
#(3 34 2 34 7 45 11)
#(3 6 3 9 6 49 8 17 14)
#(2 22 3 6 12)
#(2 46 3 6 12)
#(3 53 2 57 7)
#(3 61 3 9 6 25 14)
#(2 26 3 6 12)
#(2 38 2 7)
#(2 30 3 6 12)
)! !

!CXParser methodsFor: 'productions' stamp: 'cwp 12/16/2009 21:27'!
value1: tokens
	^ tokens first value! !

SmaCCScanner subclass: #CXScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXScanner class methodsFor: 'generated-comments' stamp: 'cwp 12/18/2009 10:51'!
scannerDefinitionComment

	"<whitespace>	:	\s+;
<keyword>		: 	[a-z]+;
<name>		:	[A-Za-z0-9\-_.:/]+;"! !

!CXScanner methodsFor: 'generated-tokens' stamp: 'cwp 12/18/2009 10:51'!
emptySymbolTokenId
	^12! !

!CXScanner methodsFor: 'generated-tokens' stamp: 'cwp 12/18/2009 10:51'!
errorTokenId
	^13! !

!CXScanner methodsFor: 'generated-tokens' stamp: 'cwp 12/18/2009 10:51'!
keywordId
	^6! !

!CXScanner methodsFor: 'generated-tokens' stamp: 'cwp 12/18/2009 10:51'!
nameId
	^7! !

!CXScanner methodsFor: 'generated-scanner' stamp: 'cwp 12/18/2009 10:51'!
scanForToken
	self step.
	((currentCharacter 
		between: $-
		and: $:) or: 
		[ (currentCharacter 
			between: $A
			and: $Z) or: [ currentCharacter = $_ ] ]) ifTrue: 
		[ 
		[ self recordMatch: #(7 ).
		self step.
		(currentCharacter 
			between: $-
			and: $:) or: 
			[ (currentCharacter 
				between: $A
				and: $Z) or: 
				[ currentCharacter = $_ or: 
					[ currentCharacter 
						between: $a
						and: $z ] ] ] ] whileTrue.
		^ self reportLastMatch ].
	(currentCharacter 
		between: $a
		and: $z) ifTrue: 
		[ 
		[ self recordMatch: #(6 7 ).
		self step.
		((currentCharacter 
			between: $-
			and: $:) or: 
			[ (currentCharacter 
				between: $A
				and: $Z) or: [ currentCharacter = $_ ] ]) ifTrue: 
			[ 
			[ self recordMatch: #(7 ).
			self step.
			(currentCharacter 
				between: $-
				and: $:) or: 
				[ (currentCharacter 
					between: $A
					and: $Z) or: 
					[ currentCharacter = $_ or: 
						[ currentCharacter 
							between: $a
							and: $z ] ] ] ] whileTrue.
			^ self reportLastMatch ].
		currentCharacter 
			between: $a
			and: $z ] whileTrue.
		^ self reportLastMatch ].
	((currentCharacter 
		between: Character tab
		and: Character cr) or: [ currentCharacter = Character space ]) ifTrue: 
		[ 
		[ self recordMatch: #whitespace.
		self step.
		(currentCharacter 
			between: Character tab
			and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
		^ self reportLastMatch ].
	currentCharacter = $( ifTrue: [ ^ self recordAndReportMatch: #(1 ) ].
	currentCharacter = $) ifTrue: [ ^ self recordAndReportMatch: #(2 ) ].
	currentCharacter = ${ ifTrue: [ ^ self recordAndReportMatch: #(4 ) ].
	currentCharacter = $} ifTrue: [ ^ self recordAndReportMatch: #(3 ) ].
	^ self reportLastMatch! !

TestCase subclass: #CXParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXParserTest methodsFor: 'support' stamp: 'cwp 12/16/2009 22:43'!
mc2Codex
	^ 'import Grease
import OmniBrowser

repository wiresong-mc http://source.wiresong.ca/mc

package MC2-Squeak-Platform
package MC2-Core
package MC2-Smalltalk
package MC2-Export-Chunk
package MC2-Repository-File
package MC2-Repository-Directory
package MC2-Repository-Network
package MC2-Meta-Core
package MC2-Meta-Repository-File
package MC2-Meta-Repository-Directory
package MC2-Meta-Repository-Network
package MC2-OmniBrowser
package MC2-Tests-Core
package MC2-Tests-Export-Chunk
package MC2-Tests-Repository-File
package MC2-Tests-Repository-Directory
package MC2-Tests-Repository-Network
package MC2-Tests-OmniBrowser
package MC2-Tests-Meta-Core
package MC2-Tests-Meta-Repository-File
package MC2-Tests-Meta-Repository-Directory
package MC2-Tests-Meta-Repository-Network

group DEFAULT (
	MC2-Squeak-Platform
	MC2-Core
	MC2-Smalltalk
	MC2-Squeak-Smalltalk
	MC2-Export-Chunk
	MC2-Repository-File
	MC2-Repository-Directory
	MC2-Repository-Network
	MC2-OmniBrowser
	MC2-Meta-Core
	MC2-Meta-Squeak-Smalltalk
	MC2-Meta-Repository-File
	MC2-Meta-Repository-Directory
	MC2-Meta-Repository-Network
)

group Tests (
	MC2-Tests-Core
	MC2-Tests-Export-Chunk
	MC2-Tests-Smalltalk
	MC2-Tests-Squeak-Smalltalk
	MC2-Tests-Repository-File
	MC2-Tests-Repository-Directory
	MC2-Tests-Repository-Network
	MC2-Tests-Meta-Core
	MC2-Tests-OmniBrowser
	MC2-Tests-Meta-Squeak-Smalltalk
	MC2-Tests-Meta-Repository-File
	MC2-Tests-Meta-Repository-Directory
	MC2-Tests-Meta-Repository-Network
)

dependencies MC2-Core (
	Grease-Core
	Grease-Pharo-Core
	MC2-Platform
)

dependencies MC2-Smalltalk (MC2-Core)
dependencies MC2-Squeak-Smalltalk (MC2-Smalltalk)

dependencies MC2-Export-Chunk (
	MC2-Core 
	MC2-Smalltalk
)

dependencies MC2-Repository-File (MC2-Core)
dependencies MC2-Repository-Directory (MC2-Repository-File)
dependencies MC2-Repository-Network (MC2-Core)
dependencies MC2-Meta-Core (MC2-Core)

dependencies MC2-Meta-Squeak-Smalltalk (
	MC2-Meta-Core 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Meta-Repository-File (
	MC2-Meta-Core 
	MC2-Repository-File
)

dependencies MC2-Meta-Repository-Directory (
	MC2-Meta-Core 
	MC2-Repository-Directory
)

dependencies MC2-Meta-Repository-Network (
	MC2-Meta-Core 
	MC2-Repository-Network
)

dependencies MC2-OmniBrowser (
	MC2-Core 
	OmniBrowser 
	OB-Morphic
)

dependencies MC2-Tests-Core (MC2-Core)
dependencies MC2-Tests-Export-Chunk (MC2-Export-Chunk)

dependencies MC2-Tests-Smalltalk (
	MC2-Tests-Core
	MC2-Smalltalk 
	MC2-Meta-Core
)

dependencies MC2-Tests-Squeak-Smalltalk (
	MC2-Tests-Core 
	MC2-Tests-Smalltalk 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Tests-Repository-File (
	MC2-Tests-Core 
	MC2-Repository-File
)

dependencies MC2-Tests-Repository-Directory (
	MC2-Tests-Core 
	MC2-Repository-Directory
)

dependencies MC2-Tests-Repository-Network (
	MC2-Tests-Core 
	MC2-Repository-Network 
	MockLibrary
)

dependencies MC2-Tests-OmniBrowser (
	MC2-OmniBrowser MC2-Squeak-Smalltalk 
	MC2-Repository-Directory 
	MC2-Repository-File
	MC2-Repository-Network
	MC2-Tests-Meta-Core
	OB-Tests-Core 
)

dependencies MC2-Tests-Meta-Core (
	MC2-Tests-Core 
	MC2-Meta-Core
)

dependencies MC2-Tests-Meta-Squeak-Smalltalk (
	MC2-Tests-Meta-Core 
	MC2-Meta-Squeak-Smalltalk
)

dependencies MC2-Tests-Meta-Repository-File (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-File
)

dependencies MC2-Tests-Meta-Repository-Directory (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Directory
)

dependencies MC2-Tests-Meta-Repository-Network (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Network
)

section squeak-common {
	platform squeak
	platform pharo
	
	alias MC2-Platform MC2-SqueakPlatform
	package MC2-Squeak-Smalltalk
	package MC2-Meta-Squeak-Smalltalk
	package MC2-Tests-Squeak-Smalltalk
	package MC2-Tests-Meta-Squeak-Smalltalk	
}

section baseline-1 {
	version MC2-SqueakPlatform MC2-SqueakPlatform-cwp.37
	version MC2-Core MC2-Core-cwp.14
	version MC2-Smalltalk MC2-Smalltalk-jf.1
	version MC2-Squeak-Smalltalk MC2-Squeak-Smalltalk-cwp.12
	version MC2-Export-Chunk MC2-Export-Chunk-jf.2
	version MC2-Repository-File MC2-Repository-File-cwp.4
	version MC2-Repository-Directory MC2-Repository-Directory-jf.2
	version MC2-Repository-Network MC2-Repository-Network-cwp.3
	version MC2-Meta-Core MC2-Meta-Core-jf.4
	version MC2-Meta-Squeak-Smalltalk MC2-Meta-Squeak-Smalltalk-cwp.1
	version MC2-Meta-Repository-File MC2-Meta-Repository-File-cwp.1
	version MC2-Meta-Repository-Directory MC2-Meta-Repository-Directory-cwp.1
	version MC2-Meta-Repository-Network MC2-Meta-Repository-Network-cwp.1
	version MC2-OmniBrowser MC2-OmniBrowser-jf.4
	version MC2-Tests-Core MC2-Tests-Core-cwp.16
	version MC2-Tests-Export-Chunk MC2-Tests-Export-Chunk-cwp.2
	version MC2-Tests-Smalltalk MC2-Tests-Smalltalk-cwp.4
	version MC2-Tests-Squeak-Smalltalk MC2-Tests-Squeak-Smalltalk-cwp.10
	version MC2-Tests-Repository-File MC2-Tests-Repository-File-cwp.1
	version MC2-Tests-Repository-Directory MC2-Tests-Repository-Directory-jf.2
	version MC2-Tests-Repository-Network MC2-Tests-Repository-Network-jf.2
	version MC2-Tests-OmniBrowser MC2-Tests-OmniBrowser-cwp.1
	version MC2-Tests-Meta-Core MC2-Tests-Meta-Core-cwp.5
	version MC2-Tests-Meta-Squeak-Smalltalk MC2-Tests-Meta-Squeak-Smalltalk-cwp.2
	version MC2-Tests-Meta-Repository-File MC2-Tests-Meta-Repository-File-jf.1
	version MC2-Tests-Meta-Repository-Directory MC2-Tests-Meta-Repository-Directory-jf.1
	version MC2-Tests-Meta-Repository-Network MC2-Tests-Meta-Repository-Network-jf.1
	version MockLibrary MockLibrary-cwp.7
}

section baseline-2 {
	include baseline-1
	version MC2-Core MC2-Core-cwp.15
}

release 2.1.0 {
	blessing alpha
	include baseline-1
	include squeak-common
}

release 2.1.1 {
	blessing beta
	include baseline-2
	include squeak-common
}
'! !

!CXParserTest methodsFor: 'support' stamp: 'cwp 12/18/2009 16:45'!
parseDirective: aString 
	| section |
	section := CXParser parse: aString.
	^ section directives first! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:47'!
testAlias
	| directive |
	directive := self parseDirective: 'alias Nurp Griffle'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'alias'.
	self assert: directive name = 'Nurp'.
	self assert: directive value = 'Griffle'.! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:45'!
testExample
	self 
		shouldnt: [ CXParser parse: self mc2Codex ]
		raise: SmaCCParserError! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:44'!
testGroupOne
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value = #('Griffle').! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:47'!
testGroupTwo
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle Plonk)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value = #('Griffle' 'Plonk').! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:47'!
testGroupZero
	| directive |
	directive := self parseDirective: 'group Nurp ()'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: directive value = #().! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:47'!
testPackageName
	| directive |
	directive := self parseDirective: 'package Nurp'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'package'.
	self assert: directive name = 'Nurp'.! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:46'!
testSectionEmpty
	| directive |
	directive := self parseDirective: 'group Nurp {}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives isEmpty! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:48'!
testSectionOne
	| directive |
	directive := self parseDirective: 'group Nurp {package Plonk}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 1.
	self assert: directive value directives first name = 'Plonk'! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:48'!
testSectionTwo
	| directive text |
	text := 'group Nurp {
		package Plonk 
		package Griffle
	}'.
	directive := self parseDirective: text.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'Nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name = 'Plonk'.
	self assert: directive value directives second name = 'Griffle'! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/18/2009 16:48'!
testSectionTwoLowercase
	| directive |
	directive := self parseDirective: 'group nurp {
	package Plonk 
	package Griffle
}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive identifier = 'group'.
	self assert: directive name = 'nurp'.
	self assert: (directive value isKindOf: CXSection).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name = 'Plonk'.
	self assert: directive value directives second name = 'Griffle'! !

Object subclass: #CXDirective
	instanceVariableNames: 'identifier name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:19'!
identifier: iString name: nString
	^ self identifier: iString name: nString value: nil! !

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:19'!
identifier: iString name: nString value: anObject
	^ self basicNew 
		initializeWithIdentifier: iString 
		name: nString
		value: anObject! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
identifier
	^ identifier! !

!CXDirective methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 21:18'!
initializeWithIdentifier: iString name: nString value: anObject
	identifier := iString.
	name := nString.
	value := anObject.! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
name
	^ name! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
value
	^ value! !

Object subclass: #CXSection
	instanceVariableNames: 'directives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
directives: anArray
	^ self basicNew initializeWithDirectives: anArray! !

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
new
	^ self directives: Array new! !

!CXSection class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
with: aDirective
	^ self directives: (Array with: aDirective)! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:44'!
addDirective: aDirective
	directives := directives copyWith: aDirective! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 22:17'!
directives
	^ directives! !

!CXSection methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:42'!
initializeWithDirectives: anArray
	self initialize.
	directives := anArray! !
